capture program drop csgof
program define csgof, rclass
  version 7
  syntax varname [, EXPperc(numlist min=2) ]

  preserve

  quietly tab `varlist'
  local cat = `r(r)'
  local totn = `r(N)'
  
  if ("`expperc'"=="") {
    local percexp = 100/`cat'
    forvalues i = 1/`cat' {
      local expperc `percexp' `expperc'
    }
  }
  
  local expcat : word count `expperc'
  if (`expcat' != `cat') {
    display in red "`varlist' has `cat' categories, but expperc() has `expcat' values, `expperc'"
    display in red "Please supply `cat' values for expperc() or omit the option expperc()"
    exit
  }

  quietly table `varlist', replace
  quietly rename table1 obsfreq
  sort `varlist'

  local i = 0
  local totperc = 0
  quietly generate expfreq = .
  quietly generate expperc = .
  foreach percent of local expperc {
    local i = `i' + 1
    local totperc = `totperc' + `percent'
    quietly replace expperc = `percent' in `i'
    quietly replace expfreq = (`percent'/100)*`totn' in `i'
  }
  if abs(`totperc' - 100) > 1 {
    display in red "Expected percentages do not total to 100%"
    display in red "The sum of `expperc' is `totperc'"
    display in red "Please supply percentages that total up to 100%"
    exit
  }
  tempvar chi1 chi2
  quietly gen `chi1' = (obsfreq - expfreq)^2 / expfreq
  quietly gen `chi2' = sum(`chi1')
  local df=`cat'-1
  local pval = chi2tail(`df', `chi2'[_N])
  return scalar p = `pval'
  return scalar df = `df'
  return scalar chi2 =`chi2'[_N]
  * display _n in green "Expected Percent & Frequency and Observed Frequency"
  list `varlist' expperc expfreq obsfreq , noobs
  display _n in green "chisq(`df') is " in yellow round(`chi2'[_N],0.01) in green ", p = " in yellow round(`pval',0.0001)
  
end





